#include<bits/stdc++.h>
using namespace std;
long long a[600000];
int main()
{
    int n,m;
    cin >> n >> m;
    int a1=0;
    cin >> a[0] >> a[1];
    a[1]+=a[0];
    a1=1;
    long long t1,t2;
    for(int i=1;i<n;i++)
    {
        cin >> t1 >> t2;
        if(a[a1]>=t1)
        {
            a[a1]+=t2;
        }
        else
        {
            a1++;
            a[a1]=t1;
            a1++;
            a[a1]=t2+a[a1-1];
        }
    }
    t2=0;
    int j=2;
    bool prvi=true;
    for(int i=0;i<m;i++)
    {
        bool ispis=false;
        cin >> t1;
        if(t1<a[0])
        {
            cout << 0 << endl;
            continue;
        }
        if(prvi)
        {
            t2+=a[0]-1;
            prvi=false;
        }
        for(;j<=a1;j+=2)
        {
            if(t1<a[j-1])
            {
                cout << t1-t2<<endl;
                ispis=true;
                break;
            }
            if(t1<a[j])
            {
                cout <<a[j-1]-t2-1<<endl;
                ispis =true;
                break;
            }
            t2+=a[j]-a[j-1];
        }

        if(t1>=a[a1])
        {
            cout << a[a1]-t2-1<<endl;
            ispis=true;
        }
        if(!ispis)
            {
                cout << t1-t2<<endl;
            }
    }
}